#!/usr/bin/pypy

"""Removes duplicates from a prevertical using a duplicate ids file."""

import sys, re

if 2 > len(sys.argv) or '-h' in sys.argv:
    sys.stderr.write('Usage: %s [-v] DUPLICATES_FILE < PREVERT_FILE\n' % sys.argv[0])
    sys.exit()
verbose = '-v' in sys.argv
dup_file = sys.argv[-1]

if verbose: sys.stderr.write('Reading duplicate ids...')
duplicates = set()
for line in open(dup_file):
    duplicates.add(line.strip())
if verbose: sys.stderr.write('%d read\n' % len(duplicates))

if verbose: sys.stderr.write('Filtering documents...\n')
doc_all = doc_kept = 0
keep_doc = False
for line in sys.stdin:
    m = re.match('<doc id="([^"]+)"', line)
    if m:
        doc_all += 1
        keep_doc = m.group(1) not in duplicates
        if keep_doc:
            doc_kept += 1
        if verbose and doc_all % 10**6 == 0:
            sys.stderr.write('Doc %d\n' % doc_all)
    if keep_doc:
        sys.stdout.write(line)
if verbose: sys.stderr.write('%d/%d documents written\n' % (doc_kept, doc_all))
